local M = {}

local Number = 12345678910
local C = 3.6
local Coeff
local Check

local function ON_OFF_GM_ENGINE(ON_OFF)
for _, device in pairs(powertrain.getDevices()) do
	if ON_OFF == 1 and device.clutchMaxSafeTemp ~= Number then
		device.maxPhysicalAV = Number
		device.maxTorqueRating = Number
		device.maxOverTorqueDamage = Number
		device.clutchPermanentDamageTempThreshold = Number
		device.clutchCoolingCoef = 5000
		device.clutchWarningTemp = Number
		device.clutchMaxSafeTemp = Number
		device.gearDamageThreshold = Number
		device.canFlood = false
		device.thermals = require("powertrain/OFF_thermals")
		device.thermals.OFF_thermals()
	end
	if ON_OFF == 0 and device.clutchMaxSafeTemp == Number then
		obj:queueGameEngineLua('be:reloadVehicle(0)')
	end
end
end

local function ON_OFF_MORE_POWER(ON_OFF_1, SMOOTH, Multiplier)
local aisp = math.ceil(electrics.values.airspeed * C * 1000) / 1000
for _, device in pairs(powertrain.getDevices()) do
	Coeff = device.torqueLossCoef
	if ON_OFF_1 == 1 then
		if aisp < 15 then Coeff = -0.001 end
		if SMOOTH == 0 then
			if aisp >= 015 then Coeff = -1.000 * Multiplier end
			if aisp >= 050 then Coeff = -1.250 * Multiplier end
			if aisp >= 100 then Coeff = -1.375 * Multiplier end
			if aisp >= 150 then Coeff = -1.625 * Multiplier end
			if aisp >= 200 then Coeff = -1.750 * Multiplier end
			if aisp >= 250 then Coeff = -1.875 * Multiplier end
			if aisp >= 300 then Coeff = -2.000 * Multiplier end
			if aisp >= 350 then Coeff = -2.125 * Multiplier end
			if aisp >= 400 then Coeff = -2.250 * Multiplier end
			if aisp >= 450 then Coeff = -2.375 * Multiplier end
			if aisp >= 500 then Coeff = -2.500 * Multiplier end
		end

		if SMOOTH == 1 then
			if aisp >= 015 then Coeff = -1 * math.ceil(aisp / 150 * 100) / 100 * Multiplier end
		end
	end
	if ON_OFF_1 == 0 then
		if Coeff == nil then Check = 1 else
		if Coeff < 0 then Check = 2 end
		if Coeff > 0 then Check = 1 end end
		if Check == 2 then Coeff = 0.01 end
	end
	if device.torqueLossCoef ~= Coeff then device.torqueLossCoef = Coeff end
end
end

M.ON_OFF_GM_ENGINE = ON_OFF_GM_ENGINE
M.ON_OFF_MORE_POWER = ON_OFF_MORE_POWER
return M